#ifndef _BOX_H_
#define _BOX_H_
#include "am.h"
#include "when.h"

struct box_t;
typedef struct box_t box_t;

struct box_t {	
	uint16 runPattern;   /* 0x0000=RunnableIn, 0x0001=BlockedIn, 0x8000=cf blockPattern, 0x4000=handling, 0x2000=dead */
	uint16 blockPattern; /* Outputs we are blocked on: 0x0000=RunnableOut, 0x8000=cf runPattern  */
	when_t time; /* Of last match or output */
	
#ifdef INSTRUMENTATION	
	uint32 hpMax;  
	uint32 spMax; 
	usecs withinMax;
	usecs timeoutMax;
	usecs activeTime; /* Total time that the box was running (the RHS) */
	uint16 activeCnt; /* Incremented each time the box RHS is evaluated */
        usecs minTime;
        usecs maxTime;
#endif /*INSTRUMENTATION*/
};

void boxInit(box_t *b,int bnum);

void boxBegin(box_t *b,int bnum);
void boxEnd(box_t *b,int bnum);
#ifdef INSTRUMENTATION	
void boxVisibles(box_t *boxes, int bnum,
		 uint32 hpMaxes[],
		 uint32 spMaxes[],
		 usecs withinMaxes[],
		 usecs timeoutMaxes[],
		 usecs aveTimes[],
		 usecs minTimes[],
		 usecs maxTimes[],
		 uint16 activeCnts[]);
#endif /*INSTRUMENTATION*/

#endif /*_BOX_H_*/

