#ifndef _DEBUG_H_
#define _DEBUG_H_
#include "engine.h"

#ifdef SUPPORT_DEBUG
#include <stdio.h>
/*
 * These utility functions are purely for purposes of debugging
 *
 */

extern boolean quiet;

void dumpEscChar(FILE *file, unsigned char ch);

/* seuential 'size' heap addresses */
void dumpHeap(FILE *file, HEAP *p, uint16 size);

/* structured output */
void dumpPointer(FILE *file, HEAP *p);

void dumpWire(FILE *file, wire_t *w);

void dumpBox(FILE *file, box_t *b);

void dumpState(FILE *file);

void dumpException(FILE *file, HEAP v);

void dumpStack(FILE *file);


/*
 * These allow interactive debugging...
 *
 */
void debugArg(const char *arg);
void debugInit(const char *hamFileName);
void debugLine(const uint32 line);
void debugException(HEAP v);

#endif /*SUPPORT_DEBUG*/

#endif /*_DEBUG_H_*/
