#ifndef _WIRE_H_
#define _WIRE_H_
#include "am.h"
#include "when.h"

struct wire_t;
typedef struct wire_t wire_t;

struct wireval_t;
typedef struct wireval_t wireval_t;

struct wireval_t {
	HEAP *region; /* if boxed that region=value.hp, if unboxed then value may be a 'value', if a union potentially either case is valid */
	HEAP value;
};

struct wire_t {	
	wireval_t available;
	wireval_t pending;
	boolean pendingFlag;
	boolean availableFlag;
	when_t pendingTime; 
	when_t availableTime;
	
#ifdef INSTRUMENTATION	
	usecs withinMax;
	usecs timeoutMax;
	usecs activeTime; /* Total time that it has a value within the wire */
	uint16 activeCnt;  /* Incremented each time a value is output */
	uint32 hpMax; 
#endif /*INSTRUMENTATION*/
};

void wireInit(wire_t *w);
HEAP wireRead(wire_t *w);
void wireConsume(wire_t *w);
void wireSetPending(wire_t *w);
void wireRevokePending(wire_t *w);
void wireOutput(wire_t *w);

#ifndef UNBOXED
void copyPending(wire_t *w, HEAP *source, uint32 size);
#endif /*UNBOXED*/

#endif /*_WIRE_H_*/
