#ifndef _functions_h_
#define _functions_h_

/*
 * load the function/box rule match definitions
 *
 */
void initFunctions(); 

 
typedef enum {funcinfo_function, funcinfo_boxRule, funcinfo_boxInit, funcinfo_boxHandler} funcinfo_e;

struct funcinfo_t;
typedef struct funcinfo_t funcinfo_t;
struct funcinfo_t {
	char *name;
	int size; 
	funcinfo_e type;
	int position; /* incremented as we later fill in the match rules */
	funcinfo_t *next;
};

extern funcinfo_t *funcInfo;


funcinfo_t *findFuncInfo(char *name); /* return NULL on failure */

int findFunctionNumber(char *name); /* return -1 on failure */



struct string_t;
typedef struct string_t string_t;
struct string_t {
	string_t *next;
	char *str;
};

/* for debug */
void dumpFunctions();


/* 
 * Determine the strings, constructors, and exceptions 
 *
 */
void initStrings();

extern string_t *strings;
extern string_t *constructors; /* contains user exceptions as well */

int findConstructorNumber(char *str); /* return -1 on failure */
int findStringNumber(char *str);      /* return -1 on failure */
int findExceptionNumber(char *str);   /* return -1 on failure */

#endif /* _functions_h_ */
