#ifndef _main_h_
#define _main_h_

#if HAVE_CONFIG_H
#  include <config.h>
#endif
#include <common.h>

/*
 * Standard types and funcs
 *
 */
//typedef enum {FALSE = 0, TRUE = 1} boolean;

/* Missing when compile with -ansi on linux */
//extern char *strdup(const char *s);
//extern char *strsep(char **stringp, const char *delim);

/* Useful string utils */
extern int strindex(char *s, const char *a[], int n);
#ifndef _GNU_SOURCE
extern char *strndup(const char *s, size_t n);
#endif /* _GNU_SOURCE */

/*
 * General global flags as passed from command line
 *
 */

extern boolean verbose;
extern boolean quiet;
extern boolean idebug;
extern boolean unboxed;
extern boolean unsafe;

extern char *arch;
extern char *compiler;

#if HAVE_LONG_LONG_INT
extern long long superstepSleepTime;
#else
extern long superstepSleepTime;
#endif

/* unless -1 then override values passed from the HAM file */
extern int minHeapSize;  
extern int minWireSize; 
extern int minStackSize;


/* 
 * All console messages to go through these
 * - each prints a line
 *
 */

void infoLog(const char *fmt, ...);
void warnLog(const char *fmt, ...);

/* terminates the program */
void fatalLog(const char *fmt, ...);

#endif /*_main_h_*/

