#ifndef _ubcmp_h_
#define _ubcmp_h_

#include <stdio.h> /* FILE */

/*
 * Returns the index of a cmp%d(..) routine for the specific type 
 * - generates intermediate code as needed
 * - cmp%d command is capable of all ==,<,<=,>,>=,!= on a single type
 * Trick is to normalize the type (recursive)
 * - sizes are dropped from ints/floats/vectors/strings
 * - int/word/char/bool/enums are all treated as int
 */

int makeCmp(FILE *file, const char *type);

/*
 * Generates line of code necessary to perform comparison 'cmd' on 'type' 
 */
void makeCmpCall(FILE *file, const char *cmd, const char *type);

#endif /*_ubcmp_h_*/
