#ifndef _ubcopy_h_
#define _ubcopy_h_

#include <stdio.h> /* FILE */
#include "typing.h"

/*
 * Returns the index of a copy%d(..) routine for the specific type - generates intermediate code as needed
 * Trick is to normalize the type:
 * - firstly int/float/char/bool/enums all return -1
 * then recursively:
 * - int/float/char/bool/enum are all treated as type int, i.e. simple value copy
 * - vector and string sizes are dropped
 */

int makeWireCopy(FILE *file, type_t *type);

#endif /*_ubcopy_h_*/
